package com.example.melanie.cskiosk;

import android.content.Intent;
import android.graphics.Typeface;
import android.net.Uri;
import android.support.design.widget.TabLayout;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ExpandableListView;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.TextView;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/*CREDIT TO THE FOLLOWING TUTORIAL FOR EXPANDABLELISTVIEW HANDLING:...*/
/*http://www.androidhive.info/2013/07/android-expandable-list-view-tutorial/*/
public class classes extends AppCompatActivity {


    //expandable list view setup
    ExpandableListAdapter listAdapter;
    ExpandableListView majorListView;
    ExpandableListView concenListView;
    List<String> listDataHeader;
    HashMap<String, List<String>> listDataChild;

    //class descriptions from classdesriptions.java
    ClassDescriptions classDescriptions = new ClassDescriptions();
    ClassDescriptions.cs cs = new ClassDescriptions.cs();
    ClassDescriptions.graphdes graphdes = new ClassDescriptions.graphdes();
    ClassDescriptions.bis bis = new ClassDescriptions.bis();


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_survey);


        //set logo in action bar
        //source: https://guides.codepath.com/android/Defining-The-ActionBar
        getSupportActionBar().setDisplayShowHomeEnabled(true);
        getSupportActionBar().setLogo(R.drawable.icon);
        getSupportActionBar().setDisplayUseLogoEnabled(true);

        //major list view
        majorListView = (ExpandableListView) findViewById(R.id.major_expandable);
        MajorprepareListData();
        listAdapter = new ExpandableListAdapter(this, listDataHeader, listDataChild);
        majorListView.setAdapter(listAdapter);
        majorListView.setOnGroupClickListener(new ExpandableListView.OnGroupClickListener() {

            @Override
            public boolean onGroupClick(ExpandableListView parent, View v,
                                        int groupPosition, long id) {
                setListViewHeight(parent, groupPosition);
                return false;
            }
        });

        //concentration list view
        concenListView = (ExpandableListView) findViewById(R.id.conc_expandable);
        ConcentrationprepareListData();
        listAdapter = new ExpandableListAdapter(this, listDataHeader, listDataChild);
        concenListView.setAdapter(listAdapter);
        concenListView.setOnGroupClickListener(new ExpandableListView.OnGroupClickListener() {

            @Override
            public boolean onGroupClick(ExpandableListView parent, View v,
                                        int groupPosition, long id) {
                setListViewHeight(parent, groupPosition);
                return false;
            }
        });




        // Listview on child click listener
        concenListView.setOnChildClickListener(new ExpandableListView.OnChildClickListener() {

            @Override
            public boolean onChildClick(ExpandableListView parent, View v,
                                        int groupPosition, int childPosition, long id) {
                //Get capstone sites for each in 2017
                if (groupPosition == 0)
                {
                    if (childPosition == 0)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(cs.math131));
                        startActivity(intent);
                    }
                    if (childPosition == 1)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(cs.cs321));
                        startActivity(intent);
                    }
                    if (childPosition == 2)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(cs.cs322));
                        startActivity(intent);
                    }
                    if (childPosition == 3)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(cs.cs370));
                        startActivity(intent);
                    }
                    if (childPosition == 4)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(cs.cs330));
                        startActivity(intent);
                    }
                    if (childPosition == 5)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(cs.cs350));
                        startActivity(intent);
                    }

                }

                if (groupPosition == 1)
                {
                    if (childPosition == 0)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(graphdes.art130));
                        startActivity(intent);
                    }
                    if (childPosition == 1)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(graphdes.art280));
                        startActivity(intent);
                    }
                    if (childPosition == 2)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(graphdes.art335));
                        startActivity(intent);
                    }
                    if (childPosition == 3)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(graphdes.art350));
                        startActivity(intent);
                    }
                    if (childPosition == 4)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(graphdes.art460));
                        startActivity(intent);
                    }
                    if (childPosition == 5)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(graphdes.art485));
                        startActivity(intent);
                    }
                    if (childPosition == 6)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(graphdes.cs350));
                        startActivity(intent);
                    }
                }

                if (groupPosition == 2)
                {
                    if (childPosition == 0)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(bis.acct205));
                        startActivity(intent);
                    }
                    if (childPosition == 1)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(bis.buad270));
                        startActivity(intent);
                    }
                    if (childPosition == 2)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(bis.cs330));
                        startActivity(intent);
                    }
                    if (childPosition == 3)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(bis.math128));
                        startActivity(intent);
                    }
                    if (childPosition == 4)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(bis.buad231));
                        startActivity(intent);
                    }
                    if (childPosition == 5)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(bis.buad232));
                        startActivity(intent);
                    }
                    if (childPosition == 6)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(bis.buad233));
                        startActivity(intent);
                    }
                }

                return false;
            }
        });


        //tab select events
        TabLayout tabLayout = (TabLayout) findViewById(R.id.tabs);
        tabLayout.getTabAt(3).select();
        tabLayout.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {

            @Override
            public void onTabSelected(TabLayout.Tab tab) {

                switch (tab.getPosition()){

                    case 0:
                        Intent mainIntent = new Intent(classes.this, MainActivity.class);
                        classes.this.startActivity(mainIntent);
                        break;
                    case 1:
                        Intent infoIntent = new Intent(classes.this, about.class);
                        classes.this.startActivity(infoIntent);
                        break;
                    case 2:
                        Intent studentIntent = new Intent(classes.this, student.class);
                        classes.this.startActivity(studentIntent);
                        break;
                    case 4:
                        Intent quizIntent = new Intent(classes.this, quiz.class);
                        classes.this.startActivity(quizIntent);
                        break;
                }

            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {

            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {

            }
        });

        //Fonts
        TextView classes_title = (TextView) findViewById(R.id.classes_title);
        Typeface titlefont = Typeface.createFromAsset(getAssets(), "fonts/ka1.ttf");
        classes_title.setTypeface(titlefont);


        TextView cs_major = (TextView) findViewById(R.id.cs_major_title);
        Typeface major_and_conc = Typeface.createFromAsset(getAssets(),"fonts/DisplayOTF.otf");
        cs_major.setTypeface(major_and_conc);

        TextView cs_concentration = (TextView) findViewById(R.id.cs_major_concentrations);
        cs_concentration.setTypeface(major_and_conc);




    }

    //EXPANDABLE LIST DATA
    private void ConcentrationprepareListData() {
        listDataHeader = new ArrayList<String>();
        listDataChild = new HashMap<String, List<String>>();

        // Adding child data
        listDataHeader.add("Computer Science");
        listDataHeader.add("Graphic Design");
        listDataHeader.add("Business Information Systems");

        // Adding child data
        List<String> cs = new ArrayList<String>();
        cs.add("MATH 131 - Calculus and Analytical Geometry 1");
        cs.add("CSCI 321 - Analysis of Algorithms or CSCI 323 Theory of Computation");
        cs.add("CSCI 322 - Programming Languages");
        cs.add("CSCI 370 - Introduction to Operating Systems");
        cs.add("CSCI 350 - Event Programming Within a Windowing Environment");



        List<String> graphdesign = new ArrayList<String>();
        graphdesign.add("ART 130 - Introduction to Design");
        graphdesign.add("ART 280 - Introductory Photography and Digital Imaging");
        graphdesign.add("ART 335 - Advertising Design");
        graphdesign.add("ART 350 - Computer Graphics");
        graphdesign.add("ART 460 - Digital Studio");
        graphdesign.add("ART 485 - Design for the Web");
        graphdesign.add("CSCI 350 - Event Programming within a Windowing Environment");

        List<String> bis = new ArrayList<String>();
        bis.add("ACCT 205 - Financial Accounting");
        bis.add("BUAD 270 - Marketing Concepts and Issues");
        bis.add("CSCI 330 - Database Techniques and Modeling");
        bis.add("MATH 128 - Introductory Statistics for Business");
        bis.add("BUAD 231 - Introduction to Organizational Behavior");
        bis.add("BUAD 232 - Introduction to Human Resource Management");
        bis.add("BUAD 233 - Introduction to Operations and Supply Chain Management ");


        listDataChild.put(listDataHeader.get(0), cs); // Header, Child data
        listDataChild.put(listDataHeader.get(1), graphdesign);
        listDataChild.put(listDataHeader.get(2), bis);

    }

    private void MajorprepareListData() {
        listDataHeader = new ArrayList<String>();
        listDataChild = new HashMap<String, List<String>>();

        // Adding child data
        listDataHeader.add("CSCI 110 - Introduction to Programming");
        listDataHeader.add("CSCI 150 - Applications of Discrete Structures");
        listDataHeader.add("CSCI 205 - Software Engineering and Elementary Data Structures");
        listDataHeader.add("CSCI 220 - Advanced Data and File Structures");
        listDataHeader.add("CSCI 225 - Machine Organization and Assembly Language");
        listDataHeader.add("CSCI 460 - Senior Capstone Experience");

        // Adding child data
        List<String> cs110 = new ArrayList<String>();
        cs110.add(classDescriptions.cs110);

        List<String> cs150 = new ArrayList<String>();
        cs150.add(classDescriptions.cs150);

        List<String> cs205 = new ArrayList<String>();
        cs205.add(classDescriptions.cs205);

        List<String> cs220 = new ArrayList<String>();
        cs220.add(classDescriptions.cs220);

        List<String> cs225 = new ArrayList<String>();
        cs225.add(classDescriptions.cs225);

        List<String> cs460 = new ArrayList<String>();
        cs460.add(classDescriptions.cs460);



        listDataChild.put(listDataHeader.get(0), cs110); // Header, Child data
        listDataChild.put(listDataHeader.get(1), cs150);
        listDataChild.put(listDataHeader.get(2), cs205);
        listDataChild.put(listDataHeader.get(3), cs220);
        listDataChild.put(listDataHeader.get(4), cs225);
        listDataChild.put(listDataHeader.get(5), cs460);

    }



    //functions to ensure expandable list view works in scrollview
    //source: http://stackoverflow.com/questions/17696039/expandablelistview-inside-a-scrollview
    private void setListViewHeight(ListView listView) {
        ListAdapter listAdapter = listView.getAdapter();
        int totalHeight = 0;
        for (int i = 0; i < listAdapter.getCount(); i++) {
            View listItem = listAdapter.getView(i, null, listView);
            listItem.measure(0, 0);
            totalHeight += listItem.getMeasuredHeight();
        }

        ViewGroup.LayoutParams params = listView.getLayoutParams();
        params.height = totalHeight
                + (listView.getDividerHeight() * (listAdapter.getCount() - 1));
        listView.setLayoutParams(params);
        listView.requestLayout();
    }


    private void setListViewHeight(ExpandableListView listView,
                                   int group) {
        ExpandableListAdapter listAdapter = (ExpandableListAdapter) listView.getExpandableListAdapter();
        int totalHeight = 0;
        int desiredWidth = View.MeasureSpec.makeMeasureSpec(listView.getWidth(),
                View.MeasureSpec.EXACTLY);
        for (int i = 0; i < listAdapter.getGroupCount(); i++) {
            View groupItem = listAdapter.getGroupView(i, false, null, listView);
            groupItem.measure(desiredWidth, View.MeasureSpec.UNSPECIFIED);

            totalHeight += groupItem.getMeasuredHeight();

            if (((listView.isGroupExpanded(i)) && (i != group))
                    || ((!listView.isGroupExpanded(i)) && (i == group))) {
                for (int j = 0; j < listAdapter.getChildrenCount(i); j++) {
                    View listItem = listAdapter.getChildView(i, j, false, null,
                            listView);
                    listItem.measure(desiredWidth, View.MeasureSpec.UNSPECIFIED);

                    totalHeight += listItem.getMeasuredHeight();

                }
            }
        }

        ViewGroup.LayoutParams params = listView.getLayoutParams();
        int height = totalHeight
                + (listView.getDividerHeight() * (listAdapter.getGroupCount() - 1));
        if (height < 10)
            height = 200;
        params.height = height;
        listView.setLayoutParams(params);
        listView.requestLayout();

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement

        if (id == R.id.help_page) { //make switch case for all menu items

            Intent myIntent = new Intent(classes.this, help.class);
            classes.this.startActivity(myIntent);
            return true;
        }
        return super.onOptionsItemSelected(item);
    }
}
