package com.example.melanie.cskiosk;

import android.content.Intent;
import android.graphics.Typeface;
import android.support.design.widget.TabLayout;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.ViewGroup;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.ExpandableListView;
import android.widget.ExpandableListView.OnChildClickListener;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import android.view.View;
import android.net.Uri;

/*CREDIT TO THE FOLLOWING TUTORIAL FOR EXPANDABLELISTVIEW HANDLING:...*/
/*http://www.androidhive.info/2013/07/android-expandable-list-view-tutorial/*/
public class student extends AppCompatActivity {

    //expandable list view setup
    ExpandableListAdapter listAdapter;
    ExpandableListView expListView;
    List<String> listDataHeader;
    HashMap<String, List<String>> listDataChild;

    //studentsites
    StudentSites student = new StudentSites();
    StudentSites.Seventeen seventeen = new StudentSites.Seventeen();
    StudentSites.Sixteen sixteen = new StudentSites.Sixteen();
    StudentSites.Fifteen fifteen = new StudentSites.Fifteen();
    StudentSites.Fourteen fourteen = new StudentSites.Fourteen();



    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_student);

        //set logo in action bar
        //source: https://guides.codepath.com/android/Defining-The-ActionBar
        getSupportActionBar().setDisplayShowHomeEnabled(true);
        getSupportActionBar().setLogo(R.drawable.icon);
        getSupportActionBar().setDisplayUseLogoEnabled(true);

        //expandablelistview setup
        expListView = (ExpandableListView) findViewById(R.id.expandable);
        prepareListData();
        listAdapter = new ExpandableListAdapter(this, listDataHeader, listDataChild);
        expListView.setAdapter(listAdapter);
        expListView.setOnGroupClickListener(new ExpandableListView.OnGroupClickListener() {

            @Override
            public boolean onGroupClick(ExpandableListView parent, View v,
                                        int groupPosition, long id) {
                setListViewHeight(parent, groupPosition);
                return false;
            }
        });



        // Listview on child click listener
        expListView.setOnChildClickListener(new OnChildClickListener() {

            @Override
            public boolean onChildClick(ExpandableListView parent, View v,
                                        int groupPosition, int childPosition, long id) {
                //Get capstone sites for each in 2017
                if (groupPosition == 0)
                {
                    if (childPosition == 0)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(seventeen.carl));
                        startActivity(intent);
                    }
                    if (childPosition == 1)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(seventeen.caitlin));
                        startActivity(intent);
                    }
                    if (childPosition == 2)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(seventeen.bryan));
                        startActivity(intent);
                    }
                    if (childPosition == 3)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(seventeen.alex));
                        startActivity(intent);
                    }
                    if (childPosition == 4)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(seventeen.shelby));
                        startActivity(intent);
                    }
                    if (childPosition == 5)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(seventeen.neema));
                        startActivity(intent);
                    }
                    if (childPosition == 6)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(seventeen.kat));
                        startActivity(intent);
                    }
                }
                //class of 2016
                if (groupPosition == 1)
                {
                    if (childPosition == 0)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(sixteen.tyler));
                        startActivity(intent);
                    }
                    if (childPosition == 1)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(sixteen.everette));
                        startActivity(intent);
                    }
                    if (childPosition == 2)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(sixteen.linsey));
                        startActivity(intent);
                    }
                    if (childPosition == 3)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(sixteen.chryssy));
                        startActivity(intent);
                    }
                    if (childPosition == 4)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(sixteen.cj));
                        startActivity(intent);
                    }
                    if (childPosition == 5)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(sixteen.pat));
                        startActivity(intent);
                    }
                    if (childPosition == 6)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(sixteen.veishea));
                        startActivity(intent);
                    }
                }
                //class of 2015
                if (groupPosition == 2)
                {
                    if (childPosition == 0)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(fifteen.brad));
                        startActivity(intent);
                    }
                    if (childPosition == 1)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(fifteen.kyle));
                        startActivity(intent);
                    }
                    if (childPosition == 2)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(fifteen.derek));
                        startActivity(intent);
                    }
                    if (childPosition == 3)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(fifteen.laura));
                        startActivity(intent);
                    }
                    if (childPosition == 4)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(fifteen.garrett));
                        startActivity(intent);
                    }
                    if (childPosition == 5)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(fifteen.andrew));
                        startActivity(intent);
                    }
                    if (childPosition == 6)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(fifteen.josh));
                        startActivity(intent);
                    }
                }
                //class of 2014
                if (groupPosition == 3)
                {
                    if (childPosition == 0)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(fourteen.miles));
                        startActivity(intent);
                    }
                    if (childPosition == 1)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(fourteen.quang));
                        startActivity(intent);
                    }
                    if (childPosition == 2)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(fourteen.ryana));
                        startActivity(intent);
                    }
                    if (childPosition == 3)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(fourteen.nathan));
                        startActivity(intent);
                    }
                    if (childPosition == 4)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(fourteen.brandon));
                        startActivity(intent);
                    }
                    if (childPosition == 5)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(fourteen.cory));
                        startActivity(intent);
                    }
                    if (childPosition == 6)
                    {
                        Intent intent = new Intent();
                        intent.setAction(Intent.ACTION_VIEW);
                        intent.addCategory(Intent.CATEGORY_BROWSABLE);
                        intent.setData(Uri.parse(fourteen.david));
                        startActivity(intent);
                    }
                }
                return false;
            }
        });


        /***END EXPANDABLE ON CLICK EVENTS***/

        //TAB SELECT EVENTS
        TabLayout tabLayout = (TabLayout) findViewById(R.id.tabs);
        tabLayout.getTabAt(2).select();
        tabLayout.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {

            @Override
            public void onTabSelected(TabLayout.Tab tab) {

                switch (tab.getPosition()){

                    case 0:
                        Intent mainIntent = new Intent(student.this, MainActivity.class);
                        student.this.startActivity(mainIntent);
                        break;
                    case 1:
                        Intent infoIntent = new Intent(student.this, about.class);
                        student.this.startActivity(infoIntent);
                        break;
                    case 3:
                        Intent surveyIntent = new Intent(student.this, classes.class);
                        student.this.startActivity(surveyIntent);
                        break;
                    case 4:
                        Intent quizIntent = new Intent(student.this, quiz.class);
                        student.this.startActivity(quizIntent);
                        break;
                }

            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {

            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {

            }
        });
        //END TAB EVENTS

        /*fonts begin******************************************************************************/
        //program gallery title
       TextView student_title = (TextView) findViewById(R.id.student_title);
       TextView student_title2 = (TextView)findViewById(R.id.student_title2);
       TextView student_title3 = (TextView)findViewById(R.id.student_title3);
       TextView class_of_title = (TextView)findViewById(R.id.clasoftitle);
       TextView subtitle = (TextView) findViewById(R.id.student_subtitle);
        Typeface titlefont = Typeface.createFromAsset(getAssets(), "fonts/ka1.ttf");
        Typeface classoffont = Typeface.createFromAsset(getAssets(),"fonts/DisplayOTF.otf");
        class_of_title.setTypeface(classoffont);
        student_title.setTypeface(titlefont);
        student_title2.setTypeface(titlefont);
        student_title3.setTypeface(titlefont);
        /*fonts end********************************************************************************/
    }

    //EXPANDABLE LIST DATA
    private void prepareListData() {
        listDataHeader = new ArrayList<String>();
        listDataChild = new HashMap<String, List<String>>();

        // Adding child data
        listDataHeader.add("2017");
        listDataHeader.add("2016");
        listDataHeader.add("2015");
        listDataHeader.add("2014");

        // Adding child data
        List<String> seventeen = new ArrayList<String>();
        seventeen.add("Carl Petersson - 'Security Cam'");
        seventeen.add("Caitlin Deuchert - 'Speech to Music'");
        seventeen.add("Bryan Kelly - 'State-Space Search'");
        seventeen.add("Alex Dowlding - 'Lift Coach'");
        seventeen.add("Shelby Kirn - 'Health Quest'");
        seventeen.add("Neema Shekar - 'Hidden Messages'");
        seventeen.add("Kat Weber - 'Fancy Face'");


        List<String> sixteen = new ArrayList<String>();
        sixteen.add("Tyler Hacker - 'Stress Detection App'");
        sixteen.add("Everette Berchman - 'Speech to Music'");
        sixteen.add("Linsey Zwiefelhofer - 'Finding Fido'");
        sixteen.add("Chryssy Joski - 'Twitter Tag Clouds'");
        sixteen.add("CJ Lewis - 'Where Are You?'");
        sixteen.add("Patrick O'Connor - 'Visual Circuit Builder'");
        sixteen.add("Veishea Grebin - 'Photographic Mosaic'");

        List<String> fifteen = new ArrayList<String>();
        fifteen.add("Bradley Blank - 'Voice Editor'");
        fifteen.add("Kyle Van Den Heuvel - 'Robotic Guide'");
        fifteen.add("Derek Wachowski - 'Car Cam'");
        fifteen.add("Laura Staver - 'Health Game'");
        fifteen.add("Garrett Moody - 'Face Recognition'");
        fifteen.add("Andrew Jacobson - 'SNC Tour Guide'");
        fifteen.add("Joshua Mueller - 'Railroad Simulator'");

        List<String> fourteen = new ArrayList<String>();
        fourteen.add("Miles Lamensky - 'Cartoon App'");
        fourteen.add("Quang Bui - 'VIsual Music Conductor'");
        fourteen.add("Ryan Abendroth - 'Door to Door Scheduling'");
        fourteen.add("Nathan Heppe - 'Voice Editor'");
        fourteen.add("Brandon Fox - 'Robot Guides'");
        fourteen.add("Cory Hahn - 'SNC Tour Guide'");
        fourteen.add("David Ferris - 'Visualizing Text'");

        listDataChild.put(listDataHeader.get(0), seventeen); // Header, Child data
        listDataChild.put(listDataHeader.get(1), sixteen);
        listDataChild.put(listDataHeader.get(2), fifteen);
        listDataChild.put(listDataHeader.get(3), fourteen);
    }
    //functions to ensure expandable list view works in scrollview
    //source: http://stackoverflow.com/questions/17696039/expandablelistview-inside-a-scrollview
    private void setListViewHeight(ListView listView) {
        ListAdapter listAdapter = listView.getAdapter();
        int totalHeight = 0;
        for (int i = 0; i < listAdapter.getCount(); i++) {
            View listItem = listAdapter.getView(i, null, listView);
            listItem.measure(0, 0);
            totalHeight += listItem.getMeasuredHeight();
        }

        ViewGroup.LayoutParams params = listView.getLayoutParams();
        params.height = totalHeight
                + (listView.getDividerHeight() * (listAdapter.getCount() - 1));
        listView.setLayoutParams(params);
        listView.requestLayout();
    }


    private void setListViewHeight(ExpandableListView listView,
                                   int group) {
        ExpandableListAdapter listAdapter = (ExpandableListAdapter) listView.getExpandableListAdapter();
        int totalHeight = 0;
        int desiredWidth = View.MeasureSpec.makeMeasureSpec(listView.getWidth(),
                View.MeasureSpec.EXACTLY);
        for (int i = 0; i < listAdapter.getGroupCount(); i++) {
            View groupItem = listAdapter.getGroupView(i, false, null, listView);
            groupItem.measure(desiredWidth, View.MeasureSpec.UNSPECIFIED);

            totalHeight += groupItem.getMeasuredHeight();

            if (((listView.isGroupExpanded(i)) && (i != group))
                    || ((!listView.isGroupExpanded(i)) && (i == group))) {
                for (int j = 0; j < listAdapter.getChildrenCount(i); j++) {
                    View listItem = listAdapter.getChildView(i, j, false, null,
                            listView);
                    listItem.measure(desiredWidth, View.MeasureSpec.UNSPECIFIED);

                    totalHeight += listItem.getMeasuredHeight();

                }
            }
        }

        ViewGroup.LayoutParams params = listView.getLayoutParams();
        int height = totalHeight
                + (listView.getDividerHeight() * (listAdapter.getGroupCount() - 1));
        if (height < 10)
            height = 200;
        params.height = height;
        listView.setLayoutParams(params);
        listView.requestLayout();

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement

        if (id == R.id.help_page) { //make switch case for all menu items

            Intent myIntent = new Intent(student.this, help.class);
            student.this.startActivity(myIntent);
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

}
