package com.example.melanie.cskiosk;

import android.content.Context;
import android.content.Intent;
import android.graphics.Typeface;
import android.os.Bundle;

import android.support.design.widget.TabLayout;
import android.support.v7.app.AppCompatActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class quiz extends AppCompatActivity {

    //static ints to re-initialize at beginning of each game
    static Integer PLANETNUM = 0;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_quiz);

        //set logo in action bar
        //source: https://guides.codepath.com/android/Defining-The-ActionBar
        getSupportActionBar().setDisplayShowHomeEnabled(true);
        getSupportActionBar().setLogo(R.drawable.icon);
        getSupportActionBar().setDisplayUseLogoEnabled(true);

        StaticVars test = new StaticVars();
        test.resetplanetnum();
        test.resetpercent();

        test.questions(getApplicationContext());
        //tab select events
        TabLayout tabLayout = (TabLayout) findViewById(R.id.tabs);
        tabLayout.getTabAt(4).select();
        tabLayout.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {

            @Override
            public void onTabSelected(TabLayout.Tab tab) {

                
                switch (tab.getPosition()){

                    case 0:
                        Intent mainIntent = new Intent(quiz.this, MainActivity.class);
                        quiz.this.startActivity(mainIntent);
                        break;
                    case 1:
                        Intent infoIntent = new Intent(quiz.this, about.class);
                        quiz.this.startActivity(infoIntent);
                        break;
                    case 2:
                        Intent studentIntent = new Intent(quiz.this, student.class);
                        quiz.this.startActivity(studentIntent);
                        break;
                    case 3:
                        Intent surveyIntent = new Intent(quiz.this, classes.class);
                        quiz.this.startActivity(surveyIntent);
                        break;
                }
            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {

            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {

            }
        });


        Button start = (Button) findViewById(R.id.begin_quiz);
        start.setOnClickListener(new View.OnClickListener()
        {
            @Override
            public void onClick(View view)
            {
                /*Intent i = new Intent(getApplicationContext(), QuestionPage.class);
                i.putExtra("planet",PLANETNUM);

                Intent x = new Intent(getApplicationContext(), FeedbackPage.class);
                x.putExtra("life",8);
                x.putExtra("percent",100.0);*/

                Intent story = new Intent(quiz.this, story.class);
                quiz.this.startActivity(story);
            }
        });


        //font*********************
        TextView cyberspace_title = (TextView) findViewById(R.id.cyberspace_title);
        Typeface cyberfont = Typeface.createFromAsset(getAssets(), "fonts/game_font.otf");
        cyberspace_title.setTypeface(cyberfont);

        TextView begin_quiz = (TextView) findViewById(R.id.begin_quiz);
        begin_quiz.setTypeface(cyberfont);

        TextView game_subtitle = (TextView) findViewById(R.id.game_subtitle);
        game_subtitle.setTypeface(cyberfont);
        //*******************************
    }



    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement

        if (id == R.id.help_page) { //make switch case for all menu items

            Intent myIntent = new Intent(quiz.this, help.class);
            quiz.this.startActivity(myIntent);
            return true;
        }
        return super.onOptionsItemSelected(item);
    }
}