package com.example.melanie.cskiosk;

import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Typeface;
import android.os.Bundle;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.view.WindowManager;
import android.view.animation.AlphaAnimation;
import android.view.animation.Animation;
import android.view.animation.LinearInterpolator;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

/**
 * Created by Melanie on 3/18/2017.
 */

public class story extends AppCompatActivity {
    Boolean enable_continue = false;

    //disable back button during game
    @Override
    public void onBackPressed() {
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_story);
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);



        //story font
        final TextView cyberspace_story = (TextView) findViewById(R.id.story_text);
        final TextView cyberspace_story2 = (TextView) findViewById(R.id.story_text2);
        final TextView continuefont = (TextView) findViewById(R.id.cont);
        Typeface cyberfont = Typeface.createFromAsset(getAssets(), "fonts/game_font.otf");
        cyberspace_story.setTypeface(cyberfont);
        cyberspace_story2.setTypeface(cyberfont);
        continuefont.setTypeface(cyberfont);


        //continute button
        final Button cont = (Button) findViewById(R.id.cont);

        //view story pt two
        final ImageView down = (ImageView) findViewById(R.id.continue_story);
        final ImageView up = (ImageView) findViewById(R.id.goback_story);


        //set up blinking animation
        //http://stackoverflow.com/questions/27440481/how-to-blink-image-in-imageview-android
        final Animation animation = new AlphaAnimation(1, 0);
        animation.setDuration(1000);
        animation.setInterpolator(new LinearInterpolator());
        animation.setRepeatCount(Animation.INFINITE);
        animation.setRepeatMode(Animation.REVERSE);
        //down.startAnimation(animation);
        //up.startAnimation(animation);
        ///////////////////////////////

        //scroll thru story
        down.setOnClickListener(new View.OnClickListener()
        {
            @Override
            public void onClick(View view)
            {
                enable_continue = true;
                ContinueStory(cyberspace_story,cyberspace_story2,down,up,cont);


            }
        });

        up.setOnClickListener(new View.OnClickListener()
        {
            @Override
            public void onClick(View view)
            {
                GoBackStory(cyberspace_story,cyberspace_story2,down,up);
            }
        });



        Button proceed = (Button) findViewById(R.id.cont);
        proceed.setOnClickListener(new View.OnClickListener()
        {
            @Override
            public void onClick(View view)
            {
                Intent game = new Intent(story.this, cyberspace.class);
                startActivity(new Intent(game));
            }

        });

    }

    public void ContinueStory(TextView pt1, TextView pt2, ImageView next, ImageView prev, Button cont)
    {
        pt1.setVisibility(View.INVISIBLE);
        next.setVisibility(View.INVISIBLE);


        pt2.setVisibility(View.VISIBLE);
        prev.setVisibility(View.VISIBLE);

        if (enable_continue == true)
        {
            cont.setVisibility(View.VISIBLE);
        }


    }
    public void GoBackStory(TextView pt1, TextView pt2, ImageView next, ImageView prev)
    {
        pt1.setVisibility(View.VISIBLE);
        next.setVisibility(View.VISIBLE);


        pt2.setVisibility(View.INVISIBLE);
        prev.setVisibility(View.INVISIBLE);


    }
}
